package jp.hishidama.swing;

import java.awt.event.*;

import javax.swing.*;

import jp.hishidama.swing.undo.TextUndoManager;

public class SampleMenuBar extends JMenuBar {
	private static final long serialVersionUID = -5550663386110611235L;

	public SampleMenuBar() {
		init();
	}

	protected JRadioButtonMenuItem drag1 = new JRadioButtonMenuItem(
			"DragWindow");

	protected JRadioButtonMenuItem drag2 = new JRadioButtonMenuItem(
			"DragBoxWindow");

	protected JRadioButtonMenuItem drag3 = new JRadioButtonMenuItem(
			"DragImageWindow");

	protected JMenuItem undo = new JMenuItem("ɖ߂(U)", 'U');

	protected JMenuItem redo = new JMenuItem("蒼(R)", 'R');

	private TextUndoManager um;

	public void init() {
		JMenu drag = new JMenu("hbO(D)");
		drag.setMnemonic('D');
		drag.setToolTipText("hbOɎgpEBhE̎ނI");
		drag.add(drag1);
		drag.add(drag2);
		drag.add(drag3);
		drag1.setToolTipText("[Iɔwi߂邪A}Vp[ɂĂ͔ɏd");
		drag2.setToolTipText("wi߂ȂBOX");
		drag3.setToolTipText("ImagehbO");
		ButtonGroup group = new ButtonGroup();
		group.add(drag1);
		group.add(drag2);
		group.add(drag3);
		drag1.setSelected(true);

		JMenu edit = new JMenu("ҏW(E)");
		edit.setMnemonic('E');
		edit.setToolTipText("eLXgtB[hUNDO/REDÕeXg");
		edit.add(undo);
		edit.add(redo);
		UndoHandler uh = new UndoHandler();
		undo.addActionListener(uh);
		redo.addActionListener(uh);

		this.add(drag);
		this.add(edit);
	}

	/**
	 * IĂhbOpEBhE̎ނԂ.
	 *
	 * @return ԍ
	 */
	public int selectedDragWindow() {
		if (drag1.isSelected())
			return 0;
		if (drag2.isSelected())
			return 1;
		if (drag3.isSelected())
			return 2;
		return 0;
	}

	public void setUndoManager(TextUndoManager um) {
		this.um = um;
	}

	/**
	 * UNDO/REDOj[̎gpۂύX.
	 *
	 */
	public void updateEditMenu() {
		undo.setEnabled(um.canUndo());
		undo.setToolTipText(um.getUndoPresentationName());
		redo.setEnabled(um.canRedo());
		redo.setToolTipText(um.getRedoPresentationName());
	}

	/**
	 * UNDO/REDOj[s郊Xi[.
	 */
	class UndoHandler implements ActionListener {
		public void actionPerformed(ActionEvent e) {
			Object s = e.getSource();
			if (s == undo) {
				um.undo();
			} else if (s == redo) {
				um.redo();
			} else {
				System.out.println(s);
			}
		}
	}
}
