package jp.hishidama.swing.util;

import java.awt.*;
import java.lang.reflect.Method;

import javax.swing.JComponent;
import javax.swing.SwingUtilities;

/**
 * Component[eBeB[.
 * <p>
 * <a target="hishidama" href=
 * "http://www.ne.jp/asahi/hishidama/home/tech/soft/java/swing/ComponentUtil.html"
 * >gp</a>
 * </p>
 *
 * @author <a target="hishidama"
 *         href="http://www.ne.jp/asahi/hishidama/home/tech/soft/java/swing.html"
 *         >Ђ</a>
 * @since 2007.02.25
 */
public class ComponentUtil {

	/**
	 * R|[lgTCYύX.
	 * <p>
	 * R|[lgɊi[Ă镶igetText()Ŏ擾jł傫ɂȂ悤 R|[lg̃TCYύXB
	 * </p>
	 *
	 * @param comp
	 *            R|[lg
	 * @see #calcComponentSizeFromText(JComponent)
	 */
	public static void resizeComponentFromText(JComponent comp) {
		comp.setSize(calcComponentSizeFromText(comp));
	}

	/**
	 * R|[lgTCYvZ.
	 * <p>
	 * R|[lgɊi[Ă镶igetText()Ŏ擾jłR|[lg̑傫ԂB
	 * </p>
	 *
	 * @param comp
	 *            R|[lg
	 * @return TCY
	 * @throws RuntimeException
	 *             getText()݂Ȃꍇ
	 * @see #calcComponentSizeFromText(JComponent, String)
	 */
	public static Dimension calcComponentSizeFromText(JComponent comp) {
		try {
			Method m = comp.getClass().getMethod("getText");
			String text = (String) m.invoke(comp);
			return calcComponentSizeFromText(comp, text);
		} catch (RuntimeException e) {
			throw e;
		} catch (Exception e) {
			throw new RuntimeException(e);
		}
	}

	/**
	 * R|[lgTCYvZ.
	 * <p>
	 * łR|[lg̑傫ԂB
	 * </p>
	 *
	 * @param comp
	 *            R|[lg
	 * @param text
	 *            
	 * @return TCY
	 * @see #getStringSize(Component, String)
	 */
	public static Dimension calcComponentSizeFromText(JComponent comp,
			String text) {
		Dimension sz = getStringSize(comp, text);
		Insets in = comp.getInsets();
		return new Dimension(sz.width + in.left + in.right, sz.height + in.top
				+ in.bottom);
	}

	/**
	 * TCY擾.
	 * <p>
	 * R|[lg̃tHggp ̃TCYԂB
	 * </p>
	 *
	 * @param comp
	 *            R|[lg
	 * @param text
	 *            
	 * @return TCY
	 */
	public static Dimension getStringSize(Component comp, String text) {
		FontMetrics fm = comp.getFontMetrics(comp.getFont());
		int w = SwingUtilities.computeStringWidth(fm, text);
		int h = fm.getHeight();
		return new Dimension(w, h);
	}
}
